-- /*
-- * Licensed Materials - Property of IBM
-- * 5724-Y62 WebSphere Sensor Events
-- * (c) Copyright IBM Corp. 2009  All rights reserved.
-- *
-- * US Government Users Restricted Rights - Use, duplication or
-- * disclosure restricted by GSA ADP Schedule Contract with IBM
-- * Corp.
-- *
-- * DISCLAIMER OF WARRANTIES.  The following code is sample code
-- * created by IBM Corporation.  This sample code is part of
-- * WebSphere Sensor Events and is warranted to perform its
-- * intended function only if used unmodified.  If you modify
-- * this code then it is considered provided "AS IS", without
-- * warranty of any kind.  Notwithstanding the foregoing, IBM
-- * shall not be liable for any damages arising out of your use
-- * of the sample code, even if they have been advised of the
-- * possibility of such damages.
-- */

CREATE USER "SAMPLE" PROFILE "DEFAULT" IDENTIFIED BY "ibmrf1d" 
    DEFAULT 
    TABLESPACE "USERS" TEMPORARY 
    TABLESPACE "TEMP" QUOTA UNLIMITED  
    ON USERS ACCOUNT UNLOCK;
GRANT "CONNECT" TO "SAMPLE";
GRANT SELECT ON DBA_PENDING_TRANSACTIONS TO "SAMPLE";

DROP TABLE SAMPLE.PERSISTENCE_PAYLOAD_EXT;
DROP TABLE SAMPLE.PERSISTENCE_METADATA;
DROP TABLE SAMPLE.PERSISTENCE_PAYLOAD;
DROP TABLE SAMPLE.PERSISTENCE_HEADER;

CREATE TABLE SAMPLE.PERSISTENCE_HEADER (
	EVENT_ID VARCHAR2 (250) NOT NULL, 
	SOURCE_ID VARCHAR2 (250) NOT NULL, 
	SOURCE_NAME VARCHAR2 (250) NOT NULL, 
	EVENT_TYPE VARCHAR2 (250) NOT NULL, 
	EVENT_DATE_TIME TIMESTAMP (6) NOT NULL, 
	CONSTRAINT PK_HEADER PRIMARY KEY (EVENT_ID)
);

CREATE TABLE SAMPLE.PERSISTENCE_METADATA ( 
	EVENT_ID VARCHAR2 (250) NOT NULL, 
	ATTR_NAME VARCHAR2 (250) NOT NULL, 
	ATTR_VALUE VARCHAR2 (250), 
	CONSTRAINT PK_METADATA PRIMARY KEY (EVENT_ID, ATTR_NAME), 
	CONSTRAINT FK_METADATA FOREIGN KEY (EVENT_ID) 
		REFERENCES SAMPLE.PERSISTENCE_HEADER (EVENT_ID) 
		ON DELETE CASCADE 
);
	
CREATE TABLE SAMPLE.PERSISTENCE_PAYLOAD ( 
	EVENT_ID VARCHAR2 (250) NOT NULL, 
	TAG_IDURI VARCHAR2 (250), 
	TAG_RAWURI VARCHAR2 (250), 
	TAG_TAGID VARCHAR2 (250), 
	TAG_TAGURI VARCHAR2 (250), 
	CONSTRAINT PK_PAYLOAD PRIMARY KEY (EVENT_ID, TAG_TAGID), 
	CONSTRAINT FK_PAYLOAD FOREIGN KEY (EVENT_ID) 
		REFERENCES SAMPLE.PERSISTENCE_HEADER (EVENT_ID)  
		ON DELETE CASCADE 
);
		
CREATE TABLE SAMPLE.PERSISTENCE_PAYLOAD_EXT ( 
	EVENT_ID VARCHAR2 (250) NOT NULL, 
	TAG_TAGID VARCHAR2 (250) NOT NULL, 
	ATTR_NAME VARCHAR2 (250) NOT NULL, 
	ATTR_VALUE VARCHAR2 (250), 
	CONSTRAINT PK_PAYLOAD_EXT PRIMARY KEY (EVENT_ID, TAG_TAGID, ATTR_NAME), 
	CONSTRAINT FK_PAYLOAD_EXT FOREIGN KEY (EVENT_ID) 
		REFERENCES SAMPLE.PERSISTENCE_HEADER (EVENT_ID)  
		ON DELETE CASCADE 
);
