<%
/*
 * Licensed Materials - Property of IBM
 * 5724-Y62 WebSphere Sensor Events
 * (c) Copyright IBM Corp. 2009  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following code is sample code
 * created by IBM Corporation.  This sample code is part of
 * WebSphere Sensor Events and is warranted to perform its
 * intended function only if used unmodified.  If you modify
 * this code then it is considered provided "AS IS", without
 * warranty of any kind.  Notwithstanding the foregoing, IBM
 * shall not be liable for any damages arising out of your use
 * of the sample code, even if they have been advised of the
 * possibility of such damages.
 */
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@page import="
	java.util.Iterator,
	java.util.List,
	com.ibm.sensorevent.persistence.sample.java.Utils
	" %>
<HTML>
<HEAD>
<LINK rel="stylesheet" href="theme/Master.css" type="text/css">
<LINK rel="stylesheet" href="theme/stylesheet.css" type="text/css">
<SCRIPT language="JavaScript" src="js/utils.js"></SCRIPT>
<TITLE>Search Event Persistence</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">

<%
StringBuffer sourceNameOptions = new StringBuffer();
List sourceNames = Utils.singleton().getDistinctSourceNames();
for (Iterator i=sourceNames.iterator(); i.hasNext(); ) {
	String sourceName = (String) i.next();
	sourceNameOptions.append("<OPTION>" + sourceName + "</OPTION>\n");
}

StringBuffer eventTypeOptions = new StringBuffer();
List eventTypes = Utils.singleton().getDistinctEventTypes();
for (Iterator i=eventTypes.iterator(); i.hasNext(); ) {
	String eventType = (String) i.next();
	eventTypeOptions.append("<OPTION>" + eventType + "</OPTION>\n");
}

String dateFormat = Utils.singleton().getDateFormat();

boolean isDB2 = Utils.singleton().isDB2();
%>

</HEAD>
<BODY>

<SCRIPT language="JavaScript">
var isDB2 = "<%=isDB2%>";
var dateFormat = "<%=dateFormat%>";
</SCRIPT>

<SCRIPT type="text/JavaScript" language="JavaScript" src="/sample_persistence_web/.ibmjsfres/hxclient_v3_1.js"></script>
<%
    String s = request.getHeader("Accept-Language");
    if (s.indexOf(",") >=0) s = s.substring(0,s.indexOf(","));
    String ss = s;
    if (ss.indexOf("-") >=0) ss = ss.substring(0,ss.indexOf("-"));
    String src = new String("hxclient_S_v3_1.js");
    String enc = new String("ISO-8859-1");
    // The encoding must be an ISO encoding and not UTF-8 for the 
    // JSF date picker to work properly
    if (ss.equalsIgnoreCase("de")) {
        src = "hxclient_S_v3_1_de.js";    
        enc = "ISO-8859-1";
    } else if (ss.equalsIgnoreCase("es")) {
        src = "hxclient_S_v3_1_es.js";
        enc = "ISO-8859-1";
    } else if (ss.equalsIgnoreCase("fr")) {
        src = "hxclient_S_v3_1_fr.js";
        enc = "ISO-8859-1";
    } else if (ss.equalsIgnoreCase("it")) {
        src = "hxclient_S_v3_1_it.js";
        enc = "ISO-8859-1";
    } else if (ss.equalsIgnoreCase("ja")) {
        src = "hxclient_S_v3_1_ja.js";
        enc = "SJIS";
    } else if (ss.equalsIgnoreCase("ko")) {
        src = "hxclient_S_v3_1_ko.js";
        enc = "KSC5601";
    } else if (ss.equalsIgnoreCase("pt")) {
        src = "hxclient_S_v3_1_pt_BR.js";
        enc = "ISO-8859-1";
    } else if (s.equalsIgnoreCase("zh-TW")) {
        src = "hxclient_S_v3_1_zh_TW.js";
        enc = "big5";
    } else if (ss.equalsIgnoreCase("zh")) {
        src = "hxclient_S_v3_1_zh_CN.js";
        enc = "GBK";
    } else {
        src = "hxclient_S_v3_1.js";
        enc = "ISO-8859-1";
    }
%>
<SCRIPT charset="<%=enc%>" language="JavaScript" src="/sample_persistence_web/.ibmjsfres/<%=src%>"></SCRIPT>

<SCRIPT LANGUAGE="JavaScript">

function validateForm() {
	// handle event ID
	eventIdValue = document.getElementById("_eventId").value;

	if (eventIdValue == "") {
		document.getElementById("eventId").value = "%";
	} else if (eventIdValue != "%") {
		document.getElementById("eventId").value = "%" + eventIdValue + "%";
	} else {
		document.getElementById("eventId").value = eventIdValue;
	}
	
	// validate start and end dates
	val = document.getElementById("_startDate").value;
	vdtr = hX.getValidatorById("VSD");
	if (!vdtr.validate(val, "CSD")) {
		invalidStartDate();
		return false;
	}
	
	val = document.getElementById("_endDate").value;
	vdtr = hX.getValidatorById("VED");
	if (!vdtr.validate(val, "CED")) {
		invalidEndDate();
		return false;
	}
	
	// handle the eventDateWhere clause
	valStartDate = document.getElementById("_startDate").value;
	valEndDate = document.getElementById("_endDate").value;
	valEventDateWhereClause = "";
	if (isDB2 == "true") {
		// generate where clause for DB2		
		if (valStartDate.length > 0) {
			valEventDateWhereClause += " AND H.EVENT_DATE_TIME >= '" + normalizeDate(valStartDate, dateFormat) + " 00:00:00' ";
		}
		
		if (valEndDate.length > 0) {
			valEventDateWhereClause += " AND H.EVENT_DATE_TIME < '" + normalizeDate(valEndDate, dateFormat) + " 24:00:00' ";
		}
		
		document.getElementById("eventDateWhereClause").value = valEventDateWhereClause;
	} else {
		// generate where clause for Oracle
		if (valStartDate.length > 0) {	
			valEventDateWhereClause += " AND H.EVENT_DATE_TIME >= to_timestamp('" + normalizeDate(valStartDate, dateFormat) + " 00:00:00.00', 'YYYY-MM-DD HH24:MI:SS.FF')";
		}
		
		if (valEndDate.length > 0) {
			valEventDateWhereClause += " AND H.EVENT_DATE_TIME < to_timestamp('" + normalizeDate(valEndDate, dateFormat) + " 23:59:59.99', 'YYYY-MM-DD HH24:MI:SS.FF')";
		}
		
		document.getElementById("eventDateWhereClause").value = valEventDateWhereClause;
	}
	
	return true;
}

function invalidStartDate(thisObj, thisEvent) {
//use 'thisObj' to refer directly to this component instead of keyword 'this'
//use 'thisEvent' to refer to the event generated instead of keyword 'event'
	alert('Start date is not valid.');
	return false;
}

function invalidEndDate(thisObj, thisEvent) {
//use 'thisObj' to refer directly to this component instead of keyword 'this'
//use 'thisEvent' to refer to the event generated instead of keyword 'event'
	alert('End date is not valid.');
	return false;
}
</SCRIPT>

<H1>Search Event Persistence</H1>

<FORM method="post" name="rfidTagReadEventsForm" action="/sample_persistence_web/UIHandler" onsubmit="return validateForm();">
<INPUT type="hidden" name="report" value="sample_persistence/persistence_header.rptdesign">
<INPUT type="hidden" name="eventId" value="">
<INPUT type="hidden" name="eventDateWhereClause" value="">
<TABLE>
<TR>
	<TH align="left"><LABEL for="_eventId">Event ID:</LABEL></TH>
	<TD><INPUT type="text" name="_eventId" id="_eventId" size="60"></TD>
</TR>
<TR>
	<TH align="left"><LABEL for="sourceName">Source:</LABEL></TH>
	<TD>
		<SELECT name="sourceName" id="sourceName" size="1">
		<OPTION value="%" selected>All locations</OPTION>
		<%=sourceNameOptions%>
		</SELECT>
	</TD>
</TR>
<TR>
	<TH align="left"><LABEL for="eventType">Event Type:</LABEL></TH>
	<TD>
		<SELECT name="eventType" id="eventType" size="1">
		<OPTION value="%" selected>All event types</OPTION>
		<%=eventTypeOptions%>
		</SELECT>
	</TD>
</TR>
<TR>
	<TH align="left"><LABEL for="_startDate">Start Date:</LABEL></TH>
	<TD>
		<INPUT type="text" name="_startDate" id="_startDate" size="60" value="">
	    <SCRIPT type="text/javascript" language="JavaScript">		
			hX_6.addConverter("CSD", new hX_6.DateTimeConverter("strict:2", "format:<%=dateFormat%>"));
			hX_6.addComponent("_startDate", new hX_6.JSFDatePicker("converter:CSD"));
			hX_6.addValidator("VSD", new hX_6.DateTimeValidator());
			hX_6.addBehavior("_startDate", "onblur", new hX_6.JSFBehaviorValidate("default-class:inputText", "converter:CSD", "validator:VSD", "error-function:return invalidStartDate(this, event);", "error-class:inputText_Error", "error-action:selected"));
	    </SCRIPT>	
	</TD>
</TR>
<TR>
	<TH align="left"><LABEL for="_endDate">End Date:</LABEL></TH>
	<TD>
		<INPUT type="text" name="_endDate" id="_endDate" size="60" value="">
	    <SCRIPT type="text/javascript" language="JavaScript">		
			hX_6.addConverter("CED", new hX_6.DateTimeConverter("strict:2", "format:<%=dateFormat%>"));
			hX_6.addComponent("_endDate", new hX_6.JSFDatePicker("converter:CED"));
			hX_6.addValidator("VED", new hX_6.DateTimeValidator());
			hX_6.addBehavior("_endDate", "onblur", new hX_6.JSFBehaviorValidate("default-class:inputText", "converter:CED", "validator:VED", "error-function:return invalidEndDate(this, event);", "error-class:inputText_Error", "error-action:selected"));
	    </SCRIPT>
	</TD>
</TR>
<TR>
	<TD colspan="2">
		<BR>
		<INPUT type="submit" name="_submit" id="_submit" value="Submit">
	</TD>
</TR>
</TABLE>
</FORM>

<SCRIPT type="text/javascript" language="JavaScript">
    if (hX_6) hX_6.onPageLoad();
</SCRIPT>

</BODY>
</HTML>