/*
 * Licensed Materials - Property of IBM
 * 5724-Y62 WebSphere Sensor Events
 * (c) Copyright IBM Corp. 2009  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following code is sample code
 * created by IBM Corporation.  This sample code is part of
 * WebSphere Sensor Events and is warranted to perform its
 * intended function only if used unmodified.  If you modify
 * this code then it is considered provided "AS IS", without
 * warranty of any kind.  Notwithstanding the foregoing, IBM
 * shall not be liable for any damages arising out of your use
 * of the sample code, even if they have been advised of the
 * possibility of such damages.
 */

package com.ibm.sensorevent.persistence.sample.servlet;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.sensorevent.persistence.sample.java.Utils;

/**
 * Servlet implementation class for Servlet: UIHandler
 *
 */
 public class UIHandler extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	public static final String COPYRIGHT = 
		"Licensed Materials - Property of IBM " +
		"5724-Y62 WebSphere Sensor Events " +
		"(c) Copyright IBM Corp. 2009  All rights reserved. " +
		"US Government Users Restricted Rights - Use, duplication or " +
		"disclosure restricted by GSA ADP Schedule Contract with IBM " +
		"Corp.";
	private static final long serialVersionUID = 1L;
	
	private Utils utils;

	public UIHandler() {
		super();
	}
	
	public void init() {
		this.utils = Utils.singleton();
	}
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doPost(request, response);
	}  	
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			String birtReport = request.getParameter("report");
			
			String fullBirtReport = this.utils.getBirtReportLocation() + birtReport;
			
			String headerLanguage = request.getHeader("Accept-Language");
			String locale = headerLanguage;
			if (headerLanguage.indexOf(",") >=0) {
				locale = headerLanguage.substring(0, headerLanguage.indexOf(","));
			}
			
			String url = "/birt-viewer/frameset" +
				"?__report=" + URLEncoder.encode(fullBirtReport, "UTF-8") + 
				"&__locale=" + URLEncoder.encode(locale, "UTF-8");
			
			for (Enumeration<?> names=request.getParameterNames(); names.hasMoreElements(); ) {
				String name = (String) names.nextElement();
				
				// ignore parameters beginning with "_"
				if (!name.startsWith("_")) {
					String value = request.getParameter(name);
					url += "&" + name + "=" + URLEncoder.encode(value, "UTF-8");
				}
			}
			
			response.sendRedirect(url);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}